/******************************************************************************
 * JBoss, a division of Red Hat                                               *
 * Copyright 2006, Red Hat Middleware, LLC, and individual                    *
 * contributors as indicated by the @authors tag. See the                     *
 * copyright.txt in the distribution for a full listing of                    *
 * individual contributors.                                                   *
 *                                                                            *
 * This is free software; you can redistribute it and/or modify it            *
 * under the terms of the GNU Lesser General Public License as                *
 * published by the Free Software Foundation; either version 2.1 of           *
 * the License, or (at your option) any later version.                        *
 *                                                                            *
 * This software is distributed in the hope that it will be useful,           *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU           *
 * Lesser General Public License for more details.                            *
 *                                                                            *
 * You should have received a copy of the GNU Lesser General Public           *
 * License along with this software; if not, write to the Free                *
 * Software Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA         *
 * 02110-1301 USA, or see the FSF site: http://www.fsf.org.                   *
 ******************************************************************************/
package org.jboss.portletbridge.seam;

import org.jboss.portletbridge.BridgeRequestScope;
import org.jboss.seam.contexts.Contexts;
import org.jboss.seam.core.Manager;

/**
 * That class get seam conversationId if long running conversation exists.
 * @author asmirnov
 * 
 */
public class ConversationIdRetriever {

   public ConversationIdRetriever() {
      // Attempt to load Manager class to detect JbossSeam classes.
      Manager.class.getName();
   }

   public void saveConversationId(BridgeRequestScope state) {
      if (Contexts.isEventContextActive()) {
         Manager manager = Manager.instance();
         if (manager.isLongRunningConversation()) {
            state.setConversationIdParameter(manager.getConversationIdParameter());
            state.setConversationId( manager.getCurrentConversationId() );
         } else {
            state.setConversationIdParameter(null);
            state.setConversationId(null);
         }
      }
   }

}
